#!/usr/bin/perl
use CGI::Carp qw(fatalsToBrowser);
require "daten/optionen.pl";


########################################################

if ($ENV{'QUERY_STRING'}) {
($s1,$s2,$s3) = split(/\&/,$ENV{'QUERY_STRING'});
($typ1,$value1) = split(/\=/,$s1);
($typ2,$value2) = split(/\=/,$s2);
($typ3,$value3) = split(/\=/,$s3);
$start = $value1;
$sortiert = $value2;
$eintragsanzahl= $value3;
} else {
$start = 0;
$sortiert = neuzuerst;
}

$stop = $start + $eintragsanzahl;

# Dateisortierung

open(SORTIERT,"$guestbookdatei");
flock(SORTIERT, 2);
@gbdatensatz = <SORTIERT>;
if ($sortiert eq neuzuerst) { @eintraege = reverse(@gbdatensatz); }
elsif ($sortiert eq altzuerst) { @eintraege = @gbdatensatz; }
close(SORTIERT);

# Zhlen der Eintragsanzahl

open(GBDATEI,"$guestbookdatei");
while(<GBDATEI>) {
$zeilen = $_;
chomp($zeilen);
$zeilenanzahl = $zeilenanzahl + 1;
}
close(GBDATEI);

# Seitenkopf

print "Content-Type: text/html\n\n";

print qq~
<html><head><title>$guestbooktitel</title></head>

<body bgcolor="$bbgc" background="$hgpic" text="$bodytext" alink="$alinkcol" link="$linkbody" vlink="$vlcol" leftmargin="$lem" topmargin="$topm" marginwidth="$margw" marginheight="$margh">
~;

# Seitenheader
open (HEADER, "header.html");
flock HEADER, 2;
@header = <HEADER>;
close HEADER;

print "@header\n";

print qq~
<div align="$tausricht">
<font face="$font" size="$groesse"><a href="$hplink">$hplinktext</a></font><br><br>

<table bgcolor="$tabrandcolor" width="$tabbbreite" cellspacing="0" cellpadding="0" border="0">
<tr>
<td>

<table width="$tabbbreite" cellpadding=4 cellspacing=1 border=0>
<tr>
<td bgcolor="$tabcolor" align="center" colspan="2">
<font face="$fonttitel" size="$titelgroesse" color="$titelfc">$guestbooktitel</font>
</td>
</tr>
<tr>
<td colspan=2 align=center bgcolor="$logobg" height="60">
<img src="$gblogo" alt="$guestbooktitel" border="0">
</td>
</tr>
<tr>
<td bgcolor="$tabcolor" colspan=2 align=center>
<b><font face="$font" size="$groesse" color="$fc"><a href=eintragen.pl>Eintragen</a></b> <b>&#187;&#187; </b>Das Gstebuch hat
~;

if ($zeilenanzahl eq "") {
print "noch keine Eintrge";
}
if ($zeilenanzahl eq "1") {
print "$zeilenanzahl Eintrag";
}
if ($zeilenanzahl > "1") {
print "$zeilenanzahl Eintrge";
}

print qq~
</font>
</td>
</tr></table></td>
</tr></table>
<br>
~;



$treffer = $start;
$ergebnisanzahl = 0;

for($i = $start; $treffer < $stop && $i < $zeilenanzahl; $i++) {

$datensatz = $eintraege[$i];
($ID,$eintragsname,$email,$homepage,$wohnort,$eintrag,$datum) = split(/\|/,$datensatz);

$treffer++;
$letztertreffer = $i;
$ergebnisanzahl++;
$tabright = $tabbbreite - $tableft;
print "<table bgcolor=\"$tabrandcolor\" width=\"$tabbbreite\" cellspacing=\"0\" cellpadding=\"0\" border=\"0\"><tr><td>\n";
print "<table cellspacing=\"1\" cellpadding=\"2\" border=\"0\">\n";
print "<tr><td colspan=\"2\" bgcolor=\"$tabnamecolor\" height=\"20\"><font size=\"$groesse\" face=\"$font\" color=\"$fc\"> Ein Eintrag von: <b>$eintragsname</b></font></td></tr>\n";
print "<tr>\n";
print "<td valign=\"top\" bgcolor=\"$tabclickcolor\" height=\"20\" width=\"$tableft\">\n";
print "<a href=\"mailto:$email\"><img src=\"$smilieurl/email.gif\" border=\"0\" alt=\"E-Mail\" width=\"86\" height=\"28\" vspace=\"2\"></a><br>\n" if ($eintragsname);
print "<a href=\"$homepage\" target=\"_blank\"><img src=\"$smilieurl/homepage.gif\" border=\"0\" alt=\"Homepage\" width=\"86\" height=\"28\" vspace=\"2\"></a><br>\n" if($homepage);
print "<img src=\"$smilieurl/wohnort.gif\" border=\"0\" alt=\"$wohnort\" width=\"86\" height=\"28\" vspace=\"2\">\n" if($wohnort);
print "</td>\n";
print "<td valign=\"top\" bgcolor=\"$tabeintragcolor\" width=\"$tabright\"><font size=\"$groesse\" face=\"$font\" color=\"$fc\">$eintrag</font></td>\n";
print "</tr><tr>\n";
print "<td colspan=\"2\" bgcolor=\"$tabdatumcolor\" height=\"20\"><b><font face=\"$font\" size=\"$fsn\" color=\"$fc\">Datum:</b> $datum</font></td>\n";
print "</tr></table></td></tr></table><br>";
}



# Nchste Ergebnisse/Links

$mehrtreffer = 0;
$startpunkt = $letztertreffer + 1;

for($i = $startpunkt; $i < $zeilenanzahl; $i++) {
$datensatz = $eintraege[$i];
($ID,$eintragsname,$email,$homepage,$wohnort,$eintrag,$datum) = split(/\|/,$datensatz);

$mehrtreffer++;
}

# Vorhergehende Ergebnisse/Links

$trefferzurueck = 0;
$zurueckstart = $start - 1;

for($i = $zurueckstart; $i >= 0 && $trefferzurueck < $eintragsanzahl; $i--) {
$datensatz = $eintraege[$i];
($ID,$eintragsname,$email,$homepage,$wohnort,$eintrag,$datum) = split(/\|/,$datensatz);

$trefferzurueck++;
$zurueckindex = $i;
}


# Tabellenende

#print "</table></td></tr></table><br>";

print qq~
<table bgcolor="$tabrandcolor" width="$tabbbreite" cellspacing="1" cellpadding="0" border="0"><tr><td>
<table bgcolor="$tabcolor" width="$tabbbreite" cellpadding=2 cellspacing=0 border=0><tr><td align=center height="20">
<font face="$fn" size="$fsn">
~;
# Weiter und vorhergehende Links Anfang


print "<a href=\"book.pl?eintragsanzahl=$zurueckindex&sortiert=$sortiert&eintrag=$eintragsanzahl\">Zurck</a> " if ($start > 0 && $trefferzurueck > 0);
print " <a href=\"book.pl?eintragsanzahl=$startpunkt&sortiert=$sortiert&eintrag=$eintragsanzahl\">Nchste</a>" if ($mehrtreffer > 0);

# Weiter und vorhergehende Links Ende

print qq~
</font></td></tr></table></td></tr></table>
~;

# Seitenfooter
open (FOOTER, "footer.html");
flock FOOTER, 2;
@footer = <FOOTER>;
close FOOTER;
print "@footer\n";

print "</body></html>";

