#!/usr/bin/perl

require "daten/optionen.pl";



if ($ENV{"REQUEST_METHOD"} eq 'GET') {
$input = $ENV{'QUERY_STRING'};
}
else {
read(STDIN, $input, $ENV{'CONTENT_LENGTH'});
}
@pairs = split(/&/, $input);
foreach $pair (@pairs) {
($name, $value) = split(/=/, $pair);
$value =~ tr/+/ /;
$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
$FORM{$name} = $value;
}

$ID = $FORM{'ID'};
$eintragsname = $FORM{'eintragsname'};
$email = $FORM{'email'};
$homepage = $FORM{'homepage'};
$wohnort = $FORM{'wohnort'};
$eintrag = $FORM{'eintrag'};
$aktion = $FORM{'aktion'};

# http:// einfgen in URL falls entfernt

if ($homepage && $homepage =~ /^http:\/\//){
$homepage = "$homepage";
} elsif ($homepage) {
$homepage = "http://$homepage";
}

# Datumsroutine

@tage = ('Sonntag','Montag','Dienstag','Mittwoch','Donnerstag','Freitag','Samstag');
@monate = ('Januar','Februar','Maerz','April','Mai','Juni','Juli','August','September','Oktober','November','Dezember');
($sec, $min, $stunde, $mtag, $mon, $jahr, $tag, $nr_tag, $isdst) = localtime(time);
if($stunde < 10) { $stunde = "0$stunde"; }
if ($min < 10) { $min = "0$min"; }
if ($sec < 10) { $sec = "0$sec"; }
$jahr = 1900 + $jahr;
$datum = "$tage[$tag], $mtag. $monate[$mon] , $jahr";

# Pflichtfelder prfen

if ($aktion eq eintragen && $eintragsname eq '') {
$mitteilung .= "<li>Bitte das Feld \"Dein Name\" ausfllen!"; 
}

if ($aktion eq eintragen && $eintragsname =~ m/<|>/) {
$mitteilung .= "<li>Das Feld \"Dein Name\" enthlt unzulssige Zeichen, es sind nur Buchstaben/Zahlen erlaubt!"; 
}

if ($aktion eq eintragen && $wohnort =~ m/<|>/) {
$mitteilung .= "<li>Das Feld \"Wohnort\" enthlt unzulssige Zeichen, es sind nur Buchstaben/Zahlen erlaubt!"; 
}

if ($aktion eq eintragen && $homepage =~ m/<|>/) {
$mitteilung .= "<li>Das Feld \"Wohnort\" enthlt unzulssige Zeichen, es sind nur Buchstaben/Zahlen erlaubt!"; 
}

if ($aktion eq eintragen && $eintrag eq '') {
$mitteilung .= "<li>Bitte in das Feld \"Dein Eintrag\" etwas eingeben!"; 
}

if ($aktion eq eintragen && $eintrag =~ m/<|>/) {
$mitteilung .= "<li>Das Feld \"Dein Eintrag\" enthlt unzulssige Zeichen, es sind nur Buchstaben/Zahlen erlaubt!"; 
}

if ($aktion ne eintragen || $email =~ /.+\@.+\..+/) {
} else {
$mitteilung .= "<li>Das Format der \"E-Mail\" Adresse ist ungltig!"; 
$ungueltig = Fehlermeldung;
}

if ($aktion eq eintragen && $email eq '') {
$mitteilung .= "<li>Bitte in das Feld \"E-Mail\" etwas eingeben!"; 
}

if ($aktion ne eintragen || $homepage eq '' || $homepage =~ /\./i) {
} else {
$mitteilung .= "<li>Das Format der \"Homepage URL\" Adresse ist ungltig!"; 
$ungueltig = Fehlermeldung;
}
##########################################################################


$zeile = $FORM{'eintrag'};


@alle_worte = split / /, $zeile;
foreach $wort (@alle_worte) {
$i=0;
my @buchstaben = map $i++, split //, $wort;
if ($i > $max_zeichen) {
$mitteilung .= "<li>Sie haben zuviele Zeichen ohne Leerzeichen dazwischen eingegeben!";
$ungueltig = Fehlermeldung;

}
}




##########################################################################
# Seitenkopf

print "Content-Type: text/html\n\n";

print qq~
<html><head><title>$guestbooktitel</title>

<script language="JavaScript">
<!--
function x () {
return;
}
		
function DoSmilie(addSmilie) {
var revisedMessage;
var currentMessage = document.GBEINTRAG.eintrag.value;
revisedMessage = currentMessage+addSmilie;
document.GBEINTRAG.eintrag.value=revisedMessage;
document.GBEINTRAG.eintrag.focus();
return;
}

//-->
</script>


</head>

<body bgcolor="$bbgc" background="$hgpic" text="$bodytext" alink="$alinkcol" link="$linkbody" vlink="$vlcol" leftmargin="$lem" topmargin="$topm" marginwidth="$margw" marginheight="$margh">
~;

&header;

print qq~
<div align="$tausricht">

<font face="$font" size="$groesse"><a href="$hplink">$hplinktext</a></font><br><br>

<table bgcolor="$tabrandcolor" width="$tabbbreite" cellspacing="0" cellpadding="0" border="0">
<tr>
<td>

<table width="$tabbbreite" cellpadding=2 cellspacing=1 border=0>
<tr>
<td bgcolor="$tabcolor" align="center" colspan="2">
<font face="$fonttitel" size="$titelgroesse" color="$titelfc">$guestbooktitel</font>
</td>
</tr>
<tr>
<td colspan=2 align=center bgcolor="$logobg" height="60">
<img src="$gblogo" alt="$guestbooktitel" border="0">
</td>
</tr>
<tr>
<td colspan=2 align=center bgcolor="$tabcolor">
<font face="$font" size="$groesse"><b><a href=book.pl>Gstebuch lesen</a></b></font>
</td>
</tr>
~;

# Fehlerausgabe

if ($mitteilung) {
print qq~
<tr>
<td colspan=2 bgcolor="$tabcolor"><font face="$font" size="$groesse" color="$fehlercol"><ul>$mitteilung</ul></font></td>
</tr>
~;
}

# Eintragsformular

if ($eintragsname eq '' || $email eq '' || $eintrag eq '' || $ungueltig eq Fehlermeldung) {
print qq~
<form NAME="GBEINTRAG" aktion="eintragen.pl" method=post>
<tr>
<td bgcolor="$tabcolor"><font face="$font" size="$groesse" color="$fc">Dein Name:*</font></td>
<td bgcolor="$tabcolor"><input type=text name="eintragsname" value="$eintragsname" ></td>
</tr>
<tr>
<td bgcolor="$tabcolor"><font face="$font" size="$groesse" color="$fc">E-Mail: *</font></td>
<td bgcolor="$tabcolor"><input type=text name="email" value="$email"></td>
</tr>
<tr>
<td bgcolor="$tabcolor"><font face="$font" size="$groesse" color="$fc">Homepage :</font></td>
<td bgcolor="$tabcolor"><input type=text name="homepage" value="$homepage"> </td>
</tr> 
<tr>
<td bgcolor="$tabcolor"><font face="$font" size="$groesse" color="$fc">Wohnort :</font></td>
<td bgcolor="$tabcolor"><input type=text name="wohnort" value="$wohnort"></td>
</tr>
<tr>
<td valign="top" bgcolor="$tabcolor"><font face="$font" size="$groesse" color="$fc">Dein Eintrag: *</font></td>
<td valign="top" bgcolor="$tabcolor">
<textarea name="eintrag" cols=47 rows=5>$eintrag</textarea> 
</td>
</tr>
<tr>
<td height="25" bgcolor="$tabcolor" colspan="2"><font face="$font" size="$groesse" color="$fc">Klicksmilies:</font>
<a href="javascript: x()" onClick="DoSmilie(' :) ');"><img src="$smilieurl/smile.gif" border="0" alt="Lcheln"></a>&nbsp; 
<a href="javascript: x()" onClick="DoSmilie(' :D ');"><img src="$smilieurl/biggrin.gif" border="0" alt="Grins"></a>&nbsp; 
<a href="javascript: x()" onClick="DoSmilie(' ;) ');"><img src="$smilieurl/wink.gif" border="0" alt="Zwinkern"></a>&nbsp; 
<a href="javascript: x()" onClick="DoSmilie(' :censored: ');"><img src="$smilieurl/censored.gif" border="0" alt="Zensiert"></a>&nbsp; 
<a href="javascript: x()" onClick="DoSmilie(' :cool: ');"><img src="$smilieurl/cool.gif" border="0" alt="Cool"></a>&nbsp; 
<a href="javascript: x()" onClick="DoSmilie(' :oops: ');"><img src="$smilieurl/eek.gif" border="0" alt="Ooops"></a>&nbsp; 
<a href="javascript: x()" onClick="DoSmilie(' :engel: ');"><img src="$smilieurl/engel.gif" border="0" alt="Engel"></a>&nbsp; 
<a href="javascript: x()" onClick="DoSmilie(' :( ');"><img src="$smilieurl/frown.gif" border="0" alt="Traurig"></a>&nbsp; 
<a href="javascript: x()" onClick="DoSmilie(' :rotwerd: ');"><img src="$smilieurl/rotwerd.gif" border="0" alt="Rotwerd"></a>&nbsp; 
<a href="javascript: x()" onClick="DoSmilie(' :smokin: ');"><img src="$smilieurl/smokin.gif" border="0" alt="Rauchen"></a>&nbsp; 
</td>
</tr>
<tr>
<td colspan=2 align=center bgcolor="$tabcolor"><input type=submit value="Eintragen">&nbsp;<input type=reset value="Abbrechen">
<input type=hidden name="aktion" value="eintragen">
</td>
</tr></form>
<tr>
<td colspan=2 bgcolor="$tabcolor">
<font face="$font" size="$groesse" color="$fc">* Pflichtfeld , HTML Tags oder Zeichen wie &lt; oder &gt; werden nicht untersttzt</font>
</td>
</tr>
</table></td></tr></table>
~;
&footer;
print "</body></html>";


} else {
&floodcheck;
# HTML Tags entfernen und Zeilenumbrche zu <br> umwandeln
$eintrag =~ s/\|/&nbsp;/g;
$eintrag =~ s/>/&gt;/g;
$eintrag =~ s/</&lt;/g;
$eintrag =~ s/\n/<br>/g;
$eintrag =~ s/\r//g;
$eintrag =~ s/\:\)/<img src=\"$smilieurl\/smile.gif\" border=\"0\">/g;
$eintrag =~ s/\:D/<img src=\"$smilieurl\/biggrin.gif\" border=\"0\">/g;
$eintrag =~ s/\;\)/<img src=\"$smilieurl\/wink.gif\" border=\"0\">/g;
$eintrag =~ s/\:censored:/<img src=\"$smilieurl\/censored.gif\" border=\"0\">/g;
$eintrag =~ s/\:cool:/<img src=\"$smilieurl\/cool.gif\" border=\"0\">/g;
$eintrag =~ s/\:oops:/<img src=\"$smilieurl\/eek.gif\" border=\"0\">/g;
$eintrag =~ s/\:engel:/<img src=\"$smilieurl\/engel.gif\" border=\"0\">/g;
$eintrag =~ s/\:\(/<img src=\"$smilieurl\/frown.gif\" border=\"0\">/g;
$eintrag =~ s/\:rotwerd:/<img src=\"$smilieurl\/rotwerd.gif\" border=\"0\">/g;
$eintrag =~ s/\:smokin:/<img src=\"$smilieurl\/smokin.gif\" border=\"0\">/g;

# Vergabe einer Eintrags ID zum eindeutigen Zuordnen in der GB Administration 

open(ID,"daten/counter.txt");
$ID = <ID>;
close(ID);
                
$ID++;

open(IDC,">daten/counter.txt") || die $!;
print IDC "$ID";
close(IDC);


# Datei speichem
require "mails.pl";

open(GBDATEN,">>$guestbookdatei");
flock(GBDATEN, 2);
print GBDATEN "$ID|$eintragsname|$email|$homepage|$wohnort|$eintrag|$datum\n";
close(GBDATEN);


# Ausgabe der Vorschau
# Hier in dem Abschnitt wird nun eine Eintragsvorschau angezeigt

print qq~
<tr>
<td colspan=2 bgcolor="$tabcolor">
<font face="$font" size="$groesse" color="$fc">Vielen Dank fr Deinen Eintrag. Hier siehst Du eine Vorschau dessen was im Gstebuch erscheint.</font>
</td>
</tr>
<tr>
<td colspan=2 bgcolor="$tabcolor"><font face="$font" size="$groesse" color="$fc">
<b>$eintragsname</b> <a href=\"mailto:$email\"><img src=\"$smilieurl/email.gif\" border=\"0\" alt=\"E-Mail\"></a>
~;

print " <a href=\"$homepage\" target=\"_blank\"><img src=\"$smilieurl/homepage.gif\" border=\"0\" alt=\"Homepage\"></a></a>\n" if($homepage);
print "<br>$wohnort\n" if($wohnort);

# Der Eintrag selbst und der Datum

print qq~

<hr>
<br>$eintrag
<hr>
<br>Datum: $datum
</font></td>
</tr></table></td></tr></table>
~;
&footer;
print "</body></html>";
}

##########################################################
sub floodcheck { 
$wartezeit = "1.0"; 
$sperrlistenlaenge = 15; 
my $IP_Nummer = $ENV{'REMOTE_ADDR'};
my $aktionszeit = time(); 
unless (-e "Zeitlimit") { 

mkdir ("Zeitlimit", 0777); 
chmod(0777, "Zeitlimit"); 
} 
open(ZEITLIMIT, "Zeitlimit/limit.dat"); 
@letzte_eintraege = <ZEITLIMIT>; 
close(ZEITLIMIT); 
foreach (@letzte_eintraege) { 
if (/^$IP_Nummer/){ 
($junk,$letzte_aktionszeit) = split(/\|!!\|/,$_); 
chomp($letzte_aktionszeit); 
last; 
} 
} # ende foreach 
$wartezeit *= $floodsperre; # zeit in sek bis neu gepostet werden darf 

if ( int(($aktionszeit - $letzte_aktionszeit) < $wartezeit)){ 
print qq~
<tr>
<td colspan=2 bgcolor="$tabcolor">
<div align="center"><font face="Verdana, Arial" size="4"><b>Anti Spam Protection</b></font><br> 
<font face="Verdana, Arial" size="2" color="#ff0000"><b>
Sie mssen $wartezeit Sekunden warten bis Sie wieder eine Aktion ausfhren knnen.</b></font>
</div>
</td></tr></table></td></tr></table>
~;
&footer;
print "</body></html>"; 
exit; 
} 
else { 
if (unshift(@letzte_eintraege, "$IP_Nummer|!!|$aktionszeit\n") > $sperrlistenlaenge){ 
$#letzte_eintraege = $sperrlistenlaenge; 
} 

open(ZEITLIMIT, ">Zeitlimit/limit.dat"); 
print ZEITLIMIT @letzte_eintraege; 
close(ZEITLIMIT); 
} 
return 1; 
} 

########################################
# Seitenheader
sub header {
open (HEADER, "header.html");
flock HEADER, 2;
@header = <HEADER>;
close HEADER;
print "@header\n";
}
########################################

########################################
# Seitenfooter
sub footer {
open (FOOTER, "footer.html");
flock FOOTER, 2;
@footer = <FOOTER>;
close FOOTER;
print "@footer\n";

}
########################################
